Subject: Re: bug#54400: Emacs error in Ubuntu

From: zimoun <[email-masked]>
Date: Wed, 16 Mar 2022 10:36:04 +0100

Hi Liliana.

On Wed, 16 Mar 2022 at 09:02, Liliana Marie Prikler <[email-masked]> wrote:

> --8<---------------cut here---------------start------------->8---
> $ ldd $GUIX_ENVIRONMENT/bin/.emacs-27.2-real | grep lzma
> 	liblzma.so.5 => /gnu/store/c8isj4jq6knv0icfgr43di6q3nvdzkx7-xz-5.2.5/lib/liblzma.so.5 (0x00007f7919fee000)
> --8<---------------cut here---------------end--------------->8---
>
> where xz is one of those magic libraries you'd expect to exist in any
> distro.  However,
>
> --8<---------------cut here---------------start------------->8---
> $ guix show emacs | recsel -p dependencies
> dependencies: [email-masked] [email-masked] [email-masked] [email-masked]
> + [email-masked] [email-masked] [email-masked] [email-masked] [email-masked] [email-masked]
> + [email-masked] [email-masked] [email-masked] [email-masked] [email-masked]
> + [email-masked] [email-masked] [email-masked] [email-masked] [email-masked]
> + [email-masked] [email-masked] [email-masked] [email-masked] [email-masked]
> + [email-masked] [email-masked] [email-masked] [email-masked]
> + [email-masked] [email-masked] [email-masked] [email-masked]
> --8<---------------cut here---------------end--------------->8---
>
> If at all, xz is included as implicit input to unpack Emacs!  We should
> probably add it as explicit input instead.

--8<---------------cut here---------------start------------->8---
$ guix graph --path emacs xz
[email-masked]
[email-masked]
[email-masked]
--8<---------------cut here---------------end--------------->8---

Note that

--8<---------------cut here---------------start------------->8---
    (source (origin
              (method url-fetch)
              (uri (string-append "mirror://gnu/emacs/emacs-"
                                  version ".tar.xz"))
--8<---------------cut here---------------end--------------->8---

but I do not see ’xz’ in the implicit inputs; only emacs-minimal.  Quick
look, maybe I miss it.

Well, indeed, something seems unexpected if the Emacs binary is linked
to liblzma and this liblzma is not an explicit inputs but instead comes
from a reference to another inputs.

Cheers,
simon